# Class AbstractSentinel<TParams, TEventData>`Abstract`

#### Type Parameters

- #### TParams extends SentinelParams<AnyConfigSchema<SentinelConfig>> = SentinelParams<SentinelConfig>

- #### TEventData extends SentinelModuleEventData = SentinelModuleEventData

#### Hierarchy

- ArchivingModule<TParams, TEventData>
  - AbstractSentinel
    - MemorySentinel

#### Implements

- SentinelModule<TParams, TEventData>

- Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:11

#####
Index

### Constructors

constructor

### Properties

_archivists
_baseModuleQueryAccountPaths
_queryAccounts
_started
_witnesses
account
commitArchivist
downResolver
eventData
history
moduleConfigQueryValidator
params
readArchivist
supportedQueryValidator
upResolver
writeArchivist
configSchema
defaultLogger?

### Accessors

_queryAccountPaths
address
allowAnonymous
config
logger
queries
queryAccountPaths
queryAccounts

### Methods

addArchivist
addWitness
bindHashes
bindHashesInternal
bindQuery
bindQueryInternal
bindQueryResult
clearListeners
discover
emit
emitSerial
getArchivists
getWitnesses
initializeQueryAccounts
listenerCount
loadAccount
moduleAccountQuery
off
offAny
on
onAny
once
query
queryHandler
queryable
removeArchivist
removeWitness
report
resolve
resolveArchivists
start
started
stop
storeToArchivists
subscribe
validateConfig
create
factory

## Constructors

### constructor

- new AbstractSentinel<TParams, TEventData>(params): AbstractSentinel<TParams, TEventData>

- #### Type Parameters

  - #### TParams extends SentinelParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.node.sentinel";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    archivists?: string[];
    schema: string;
    }, "schema"> & {
    schema: "network.xyo.node.sentinel";
    witnesses?: string[];
    } & {
    schema: string;
    }, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined> = SentinelParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.node.sentinel";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    archivists?: string[];
    schema: string;
    }, "schema"> & {
    schema: "network.xyo.node.sentinel";
    witnesses?: string[];
    } & {
    schema: string;
    }, "schema">, undefined>

  - #### TEventData extends SentinelModuleEventData<TEventData> = SentinelModuleEventData

  #### Parameters

  - ##### params: TParams

  #### Returns AbstractSentinel<TParams, TEventData>

  Inherited from ArchivingModule.constructor

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:22

## Properties

### `Private` _archivists

_archivists: any

- Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:14

### `Protected` `Readonly` _baseModuleQueryAccountPaths

_baseModuleQueryAccountPaths: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", string>

Inherited from ArchivingModule._baseModuleQueryAccountPaths

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:16

### `Protected` `Readonly` _queryAccounts

_queryAccounts: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", undefined | AccountInstance>

Inherited from ArchivingModule._queryAccounts

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:17

### `Protected` _started

_started: boolean

Inherited from ArchivingModule._started

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:18

### `Private` _witnesses

_witnesses: any

- Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:15

### `Protected` `Readonly` account

account: AccountInstance

Inherited from ArchivingModule.account

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:19

### `Protected` commitArchivist

commitArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from ArchivingModule.commitArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:44

### `Readonly` downResolver

downResolver: CompositeModuleResolver

Implementation of SentinelModule.downResolver

Inherited from ArchivingModule.downResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:14

### eventData

eventData: TEventData

Implementation of SentinelModule.eventData

Inherited from ArchivingModule.eventData

- Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:4

### history

history: (SchemaFields & PayloadFields & BoundWitnessFields & {
schema: "network.xyo.boundwitness";
})[]

- Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:13

### `Protected` `Readonly` moduleConfigQueryValidator

moduleConfigQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from ArchivingModule.moduleConfigQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:20

### `Readonly` params

params: TParams

Implementation of SentinelModule.params

Inherited from ArchivingModule.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Protected` readArchivist

readArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from ArchivingModule.readArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:80

### `Protected` `Readonly` supportedQueryValidator

supportedQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from ArchivingModule.supportedQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:21

### `Readonly` upResolver

upResolver: CompositeModuleResolver

Implementation of SentinelModule.upResolver

Inherited from ArchivingModule.upResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:15

### `Protected` writeArchivist

writeArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from ArchivingModule.writeArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:116

### `Static` configSchema

configSchema: string

Overrides ArchivingModule.configSchema

- Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:12

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from ArchivingModule.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

## Accessors

### `Protected` _queryAccountPaths

- get _queryAccountPaths(): Record<"network.xyo.query.sentinel.report", string>

- #### Returns Record<"network.xyo.query.sentinel.report", string>

  Overrides ArchivingModule._queryAccountPaths

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:17

### address

- get address(): string

- #### Returns string

  Implementation of SentinelModule.address

  Inherited from ArchivingModule.address

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:23

### allowAnonymous

- get allowAnonymous(): boolean

- #### Returns boolean

  Inherited from ArchivingModule.allowAnonymous

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:24

### config

- get config(): TParams["config"]

- #### Returns TParams["config"]

  Implementation of SentinelModule.config

  Inherited from ArchivingModule.config

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:25

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from ArchivingModule.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### queries

- get queries(): string[]

- #### Returns string[]

  Implementation of SentinelModule.queries

  Overrides ArchivingModule.queries

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:16

### queryAccountPaths

- get queryAccountPaths(): Readonly<Record<string, undefined | string>>

- #### Returns Readonly<Record<string, undefined | string>>

  Inherited from ArchivingModule.queryAccountPaths

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:27

### queryAccounts

- get queryAccounts(): Readonly<Record<string, undefined | AccountInstance>>

- #### Returns Readonly<Record<string, undefined | AccountInstance>>

  Inherited from ArchivingModule.queryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:28

## Methods

### addArchivist

- addArchivist(address): void

- #### Parameters

  - ##### address: string[]

  #### Returns void

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:18

### addWitness

- addWitness(address): void

- #### Parameters

  - ##### address: string[]

  #### Returns void

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:19

### `Protected` bindHashes

- bindHashes(hashes, schema, account?): PromiseEx<unknown, AccountInstance>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<unknown, AccountInstance>

  Inherited from ArchivingModule.bindHashes

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:39

### `Protected` bindHashesInternal

- bindHashesInternal(hashes, schema, account?): Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

  Inherited from ArchivingModule.bindHashesInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:40

### `Protected` bindQuery

- bindQuery<T>(query, payloads?, account?): PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

  Inherited from ArchivingModule.bindQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:41

### `Protected` bindQueryInternal

- bindQueryInternal<T>(query, payloads?, account?): Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from ArchivingModule.bindQueryInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:42

### `Protected` bindQueryResult

- bindQueryResult<T>(query, payloads, additionalWitnesses?): PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` additionalWitnesses: AccountInstance[]

  #### Returns PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

  Inherited from ArchivingModule.bindQueryResult

  - Defined in modules/packages/archivist/dist/types/ArchivingModule.d.ts:14

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: keyof TEventData | (keyof TEventData)[]

  #### Returns void

  Implementation of SentinelModule.clearListeners

  Inherited from ArchivingModule.clearListeners

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:7

### discover

- discover(): Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

  Inherited from ArchivingModule.discover

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:32

### emit

- emit<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends string | number | symbol = keyof TEventData

  - #### TEventArgs extends EventArgs = TEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Implementation of SentinelModule.emit

  Inherited from ArchivingModule.emit

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:8

### emitSerial

- emitSerial<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends string | number | symbol = keyof TEventData

  - #### TEventArgs extends EventArgs = TEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Implementation of SentinelModule.emitSerial

  Inherited from ArchivingModule.emitSerial

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:9

### getArchivists

- getArchivists(account?): Promise<ArchivistWrapper<ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.archivist.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<{
  parents?: ArchivistParents;
  schema: "network.xyo.archivist.config";
  storeParentReads?: boolean;
  } & Omit<undefined, "schema">, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ArchivistModuleEventData>>[]>

- #### Parameters

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<ArchivistWrapper<ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.archivist.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<{
  parents?: ArchivistParents;
  schema: "network.xyo.archivist.config";
  storeParentReads?: boolean;
  } & Omit<undefined, "schema">, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ArchivistModuleEventData>>[]>

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:20

### getWitnesses

- getWitnesses(account?): Promise<WitnessWrapper[]>

- #### Parameters

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<WitnessWrapper[]>

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:53

### `Protected` initializeQueryAccounts

- initializeQueryAccounts(): void

- #### Returns void

  Inherited from ArchivingModule.initializeQueryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:77

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: keyof TEventData | (keyof TEventData)[]

  #### Returns number

  Implementation of SentinelModule.listenerCount

  Inherited from ArchivingModule.listenerCount

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:10

### `Protected` loadAccount

- loadAccount(account?): AccountInstance

- #### Parameters

  - ##### `Optional` account: AccountInstance

  #### Returns AccountInstance

  Inherited from ArchivingModule.loadAccount

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:78

### moduleAccountQuery

- moduleAccountQuery(): Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

  Inherited from ArchivingModule.moduleAccountQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:33

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns void

  Implementation of SentinelModule.off

  Inherited from ArchivingModule.off

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:11

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Implementation of SentinelModule.offAny

  Inherited from ArchivingModule.offAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:12

### on

- on<TEventName>(eventNames, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of SentinelModule.on

  Inherited from ArchivingModule.on

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:13

### onAny

- onAny(listener): (() => void)

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of SentinelModule.onAny

  Inherited from ArchivingModule.onAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:14

### once

- once<TEventName>(eventName, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of SentinelModule.once

  Inherited from ArchivingModule.once

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:15

### query

- query<T, TConfig>(query, payloads?, queryConfig?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Implementation of SentinelModule.query

  Inherited from ArchivingModule.query

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:34

### `Protected` queryHandler

- queryHandler<T, TConfig>(query, payloads?, queryConfig?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Overrides ArchivingModule.queryHandler

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:56

### queryable

- queryable<T, TConfig>(query, payloads?, queryConfig?): boolean

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns boolean

  Implementation of SentinelModule.queryable

  Inherited from ArchivingModule.queryable

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:35

### removeArchivist

- removeArchivist(address): void

- #### Parameters

  - ##### address: string[]

  #### Returns void

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:54

### removeWitness

- removeWitness(address): void

- #### Parameters

  - ##### address: string[]

  #### Returns void

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:55

### `Abstract` report

- report(payloads?): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Parameters

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Implementation of SentinelModule.report

  - Defined in modules/packages/sentinel/dist/types/AbstractSentinel.d.ts:57

### `Protected` resolve

- resolve<TModule>(filter?): Promise<TModule[]>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Inherited from ArchivingModule.resolve

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:113

### `Protected` resolveArchivists

- resolveArchivists(): Promise<ArchivistWrapper<ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.archivist.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<{
  parents?: ArchivistParents;
  schema: "network.xyo.archivist.config";
  storeParentReads?: boolean;
  } & Omit<undefined, "schema">, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ArchivistModuleEventData>>[]>

- #### Returns Promise<ArchivistWrapper<ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.archivist.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<{
  parents?: ArchivistParents;
  schema: "network.xyo.archivist.config";
  storeParentReads?: boolean;
  } & Omit<undefined, "schema">, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ArchivistModuleEventData>>[]>

  Inherited from ArchivingModule.resolveArchivists

  - Defined in modules/packages/archivist/dist/types/ArchivingModule.d.ts:15

### start

- start(_timeout?): Promisable<void, never>

- #### Parameters

  - ##### `Optional` _timeout: number

  #### Returns Promisable<void, never>

  Implementation of SentinelModule.start

  Inherited from ArchivingModule.start

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:36

### started

- started(notStartedAction?): boolean

- #### Parameters

  - ##### `Optional` notStartedAction: "error" | "throw" | "warn" | "log" | "none"

  #### Returns boolean

  Inherited from ArchivingModule.started

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:37

### `Protected` stop

- stop(_timeout?): Promisable<AbstractSentinel<TParams, TEventData>, never>

- #### Parameters

  - ##### `Optional` _timeout: number

  #### Returns Promisable<AbstractSentinel<TParams, TEventData>, never>

  Inherited from ArchivingModule.stop

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:114

### `Protected` storeToArchivists

- storeToArchivists(payloads): Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

- #### Parameters

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

  Inherited from ArchivingModule.storeToArchivists

  - Defined in modules/packages/archivist/dist/types/ArchivingModule.d.ts:48

### subscribe

- subscribe(_queryAccount?): void

- #### Parameters

  - ##### `Optional` _queryAccount: AccountInstance

  #### Returns void

  Inherited from ArchivingModule.subscribe

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:38

### `Protected` validateConfig

- validateConfig(config?, parents?): boolean

- #### Parameters

  - ##### `Optional` config: unknown

  - ##### `Optional` parents: string[]

  #### Returns boolean

  Inherited from ArchivingModule.validateConfig

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:115

### `Static` create

- create<TModule>(this, params?): Promise<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns Promise<TModule>

  Inherited from ArchivingModule.create

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:30

### `Static` factory

- factory<TModule>(this, params?): CreatableModuleFactory<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns CreatableModuleFactory<TModule>

  Inherited from ArchivingModule.factory

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:31

Generated using TypeDoc